#include "main.h"

//Program Definitions
BYTE isMounted=0;
BYTE MyString[40];
UINT File_Count;

//Program Functions and stuff
FATFS fs;          // Work area (file system object) for the volume

//Program Start
int main(void)
{ 
    UINT br;           // File read count
    FRESULT res;       // Petit FatFs function common result code
    UINT temp;

    setup_pll();

    ctl_global_interrupts_enable();

    PINSEL0 = 0x00000000;    //All GPIO
    PINSEL1 = 0x00000000;    //All GPIO
    IO0DIR = 0xFFB7FFFF;         //All Output except P0.22
    IO0CLR = 0xFFFFFFFF;        //All Low

    InitTimer1();
    Init_UART();

    while(1) {
        switch(isMounted)
        {
            case 0:
                if(CheckSD())
                {
                    isMounted = 1;
                    UART_STR("SD Card inserted!\n");
                }
                break;
            case 1:
                if(CheckSD())
                {

                        res = MountSD();
                        if(res)
                        {
                            isMounted = 0;
                        }
                        else
                        {
                            isMounted++;
                        }
                }
                else
                {
                  isMounted=0;
                }
                break;

            case 2:
                if(CheckSD() == 0)
                    isMounted = 0;
                if(CmdRdy)
                  ParseCommand();
                break;
        }
        if(isMounted == 2)
        {
 
        }
        //Delay_MS(300);
    }
  return 0;
}
void ParseCommand(void)
{
  FRESULT res;
  //FILE fsrc, fdst;      /* file objects */
  BYTE buffer[512];   /* file copy buffer */
  UINT br, bw;         /* File read/write count */

  if(strncmp("HELP",RX_CMD,4) == 0)
  {
    UART_STR("----------------------\n");
    UART_STR("Commands:\n");
    UART_STR("LIST X  = Where X is the Directory.\n");
    UART_STR("READ X  = Where X is the File.\n");
    UART_STR("----------------------\n");
    goto Done;
  }

  if(strncmp("LIST",RX_CMD,4) == 0)
  {
    res = scan_files(RX_ARG);
    goto Done;
  }
  
  if(strncmp("READ",RX_CMD,4) == 0)
  {
    res = pf_open(RX_ARG);
    if (res)
    {
      UART_STR("File Not Found!");
      UART_STR(RX_ARG);
      UART_STR(" \n");
    }
    else
    {
      memset(buffer,0,512);
      UART_STR("-------- FILE: ");
      UART_STR(RX_ARG);
      UART_STR(" -------- \n");
  
      res = pf_read(buffer, sizeof(buffer), &br);    /* Read a chunk of src file */
      UART_STR(buffer);
             
      UART_STR("\n-------------------------------- \n");

    }
    goto Done;
  }

Done:
  CmdRdy = 0;
}
FRESULT MountSD(void)
{
    FRESULT res;
    FRESULT resMount;

    Delay_MS(200);

    resMount = pf_mount(&fs);
    UART_STR("Mounting SD Card...");
    if (resMount) 
    {
        UART_STR("FAILED!\n");
        if(CheckSD())
        {
          MountSD();
        }
        else
        {
          isMounted=0;
        }
    }
    else
    {
        UART_STR("PASSED!\n");
        UART_STR("Type HELP for Commands.\n");
        res = scan_files("/");
    }
    return res;
}
void InitTimer1(void)
{
    /* Initialize Timer 1 */
    T1TCR=0x0;
    T1TC=0x0;
    T1PR=0x0;
    T1PC=0x0;
    /* Set the match value in the match register */
    T1MR0=7000000;
    /* Reset and interrupt on match */
    T1MCR=0x3;
    /* Initialize VIC */
    VICIntSelect=0x20; /* Timer 1 selected as FIQ */
    VICIntEnable= 0x20; /*Timer 1 interrupt enabled*/
}

//Delay Functions
void Delay_MS(int time)
{
    T1MR0=70000;
    T1TC = 0;
    while(time--)
    {
        T1TCR=0x1;
        while(!Timer1);
        T1IR |= 0x01;
    } 
}

void Delay_US(int time)
{
    T1MR0=70;
    T1TC = 0;
    while(time--)
    {
        T1TCR=0x1;
        while(!Timer1);
        T1IR |= 0x01;
    } 
}