#include "main.h"
#include <string.h>

unsigned char CurPOS=0;
unsigned char InBuffer[64];
char CurrentLine = 1;
char isSP = 0;

char DataFlag=0;
char DataRX=0;

//GLOBAL UART 
char RX_CMD[4] = {0,0,0,0};
char RX_ARG[30];
char CmdPos = 0;
char ArgPos = 0;
char CmdRdy = 0;

void Init_UART (void)
{
    int Div;
    //IO0DIR &= 0xFFFFFFFD;
    /* Initialize Pin Select Block for Tx and Rx */
    PINSEL0|=0x5;
    /* Enable FIFO's and reset them */
    U0FCR=0x7;
    /* Set DLAB and word length set to 8bits */
    U0LCR = 0x83;
    /* Baud rate set to 19200 */
    Div = (70000000/16)/19200;
    U0DLM = Div/256;
    U0DLL = Div %256;
     /* Clear DLAB */
    U0LCR = 0x03;

    U0IER = 0x05; //RDA 
    //Interrupt Setup
    VICIntEnClr     = 0xFFFFFFFF; //Disable all interrupts
    VICIntSelect = 0x00; //UART0 = IRQ Interrupt
    VICVectCntl0 = 0x26; // Vector 0 is for UART0 and is Enabled
    VICVectAddr0 = (unsigned long)UART0_ISR; //Prototype address to be called 
    VICIntEnable = 0x40; //Enable UART0 Interrupt       
}

void UART0_ISR(void) 
{
  DataFlag = 1;
  DataRX = U0RBR;
  
  if(CmdRdy == 1)
    goto Done;
  if(CmdPos<3)
  {
    RX_CMD[CmdPos++] = DataRX;
    goto Done;
  }

  if(CmdPos==3)
  {
    RX_CMD[CmdPos++] = DataRX;
    goto Done;
  }

  if(CmdPos++ <= 4)
  {
    memset(RX_ARG,0,30);
    if(strncmp("HELP",RX_CMD,4) != 0)
    {
      goto Done;
    }
    else
    {
      DataRX = LF;
    }
  }



  if(DataRX == LF)
  {
    ArgPos = 0;
    CmdPos = 0;
    CmdRdy = 1;
    goto Done;
  }

  RX_ARG[ArgPos++] = DataRX;

Done:
  VICSoftIntClear = 0x40; //Clear Interrupt        
  VICVectAddr=0xFF;
}
void UART_TX(unsigned char dataOut)
{
  U0THR = dataOut;
  while(!(U0LSR & TEMT));    //Wait until Transmit is Complete
}
void UART_STR(char* dataOut)
{
  while(*dataOut)
  {
    UART_TX(*dataOut++);
  }
}